#!/bin/sh

clear

echo "CloneIt: Client/Server based on netpipes 4.0 ..."
echo

dialog \
            --title "Server or Client: Are you serving a file?" \
            --backtitle "CloneIt" \
            --yesno "Choose YES for server (reading) or NO for client (writing)." \
            7 60
ERR="$?"

if [ "$ERR" = "0" ]; then

	dialog \
 	    --title "Server: Which file or device do you want to serve?" \
            --backtitle "CloneIt" \
 	    --inputbox "Filename/Devicename (i.e. /dev/hda)" \
            9 60 \
            2>/tmp/dialog.out
	ERR="$?"
	if [ "$ERR" != "0" ]; then
		exit;
	fi
	FILENAME=`cat /tmp/dialog.out`
	
	clear
	echo "CloneIt: Faucet is serving data from $FILENAME now ..."
	echo "         To stop the server use CTRL+C."
	echo

	faucet 1775 -out --verbose sh -c "cat $FILENAME | gzip -c --fast"

else
	dialog \
 	    --title "Client: What is the server IP?" \
            --backtitle "CloneIt" \
 	    --inputbox "Enter the IP number of the server (i.e. 192.168.0.1)." \
            9 60 \
            2>/tmp/dialog.out
	ERR="$?"
	if [ "$ERR" != "0" ]; then
		exit;
	fi
	SERVER=`cat /tmp/dialog.out`

	dialog \
 	    --title "Client: Where do you want to write the file to?" \
            --backtitle "CloneIt" \
 	    --inputbox "Enter the filename or devicename where the data gets written to (i.e. /dev/hda)." \
            9 60 \
            2>/tmp/dialog.out
	ERR="$?"
	if [ "$ERR" != "0" ]; then
		exit;
	fi
	FILENAME=`cat /tmp/dialog.out`

        dialog \
            --title "Client: Ready to copy the data from $SERVER to $FILENAME?" \
            --backtitle "CloneIt" \
            --msgbox "Press OK to continue when the server is running." \
            7 60
	ERR="$?"
	if [ "$ERR" != "0" ]; then
		exit;
	fi

	clear
	echo "CloneIt: Hose is receiving data from $SERVER and writing it to $FILENAME now ..."
	echo

	hose $SERVER 1775 --in --verbose sh -c "gzip -dc | report >$FILENAME"

	echo 
	echo "CloneIt: The transfer is completed."
	echo
fi
